%tutor en espaol de kalman filter
%este tutorial pretende integrar una implementacion rapida en matlab
% con el filtro de kalman en este caso mostraremos el proceso de entonar el
% filtro a partir de una funcion escalar , pasaremos a un escalar con ruido
% y luego a una funcion con ruido el objetivo es hacer llegar un robot a
% una distancia fija de un objeto pero como hacer llegar a esta distancia
% si los sensores que tenemos presentan ruido?
%Para ello usaremos el filtro de kalman el cual nos permite eliminar rl
%ruido d e un sistema
% consideremos la distancia a un punto fijo de u nrobot que se mueve a vel
% constante varia linealmente con el tiempo

figure(2)%iniciemos un vector de 50 muestras
hold on;
L = 100; %L es el numero de muestras
Z0=70;
%generemos un vector de ruidos que 
%simulara los valores leidos de algun sensor o muestra
n=2*randn(1,L); % la desviacion estandar del ruido es 2
z=zeros(1,L);%definimos un vector de lecturas
x=zeros(1,L);%vector d eestados nos servira despues
  


axis([0,L,0,100]);%mantenemos los ejes de acuerdo a nuestro valor 
for (i=1:L) 
    z(:,i)=Z0+n(:,i);  % las lecturas rodean 70 con desv estandar de 2.
    plot(i,z(:,i),'g'); %desplegamos las muestras   
end;

pause  
% a partir de aqui implementaremos el filtro d ekalman

%ahora apliquemos kalman
%X(K+1)=AXK+W
%Z(K)=HXK+V

Q=1;%covarianza del error =0;
H=1; %relacion entre variable medida y el sensxor 
A=1; %la relacion es 1 a 1
R=2;  %varianza en este caso 2

xm=0 ;%pocision inicial "estado inicial"
P=0; %el error inicial del proceso es 0
for (i=1:L) 
     
    
K=H*P*(1/(H*P*H+R));  %paso1 calculamos k
xm=xm+K*(z(:,i)-H*xm);%ajustamos la estimacion con la lectura
                  %plot(i,xm,'y+');
P=(1-K*H)*P
                   %calculamos la varianza
xm=A*xm;%proyectamos la media 
P=A*A*P+Q; %proyectamos la varianza
plot(i,xm,'b');
end ;

pause



